package com.qmth.demo.api.controller;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.boot.tools.signature.SignatureEntity;
import com.qmth.boot.tools.signature.SignatureType;
import com.qmth.demo.api.auth.DemoSession;
import org.springframework.web.bind.annotation.RequestAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/auth")
@Aac(auth = true)
public class AuthController {

    @Aac(auth = false)
    @RequestMapping("/demo/sig")
    public Object getSignature() {
        long time = System.currentTimeMillis();
        Map<String, Object> map = new HashMap<>();
        map.put("time", time);
        map.put("signature",
                SignatureEntity.build(SignatureType.TOKEN, "post", "/api/auth/demo", time, "invoker", "123456"));
        return map;
    }

    @RequestMapping("/demo")
    public Object security(@RequestAttribute DemoSession demoSession) {
        return demoSession;
    }

}
