package com.qmth.demo.api.controller;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.boot.core.fss.service.FileStoreService;
import com.qmth.boot.core.retrofit.utils.UploadFile;
import com.qmth.boot.tools.models.ByteArray;
import com.qmth.demo.api.client.FileTestClient;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.File;
import java.io.IOException;
import java.time.Duration;

@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/file")
@Aac(auth = false)
public class FileController {

    @Resource
    FileStoreService fileService;

    //@Resource
    //FileStore fileStore;

    @Resource
    FileTestClient fileTestClient;

    @RequestMapping("/server_url")
    public Object getServerUrl(@RequestParam String bucket, @RequestParam String path,
            @RequestParam(required = false) Long expireSecond) {
        //return fileService.getFileStore("public").getServer();
        return fileService.getFileStore(bucket)
                .getServerUrl(path, expireSecond != null ? Duration.ofSeconds(expireSecond) : null);
    }

    @RequestMapping("/server")
    public Object server() {
        //return fileService.getFileStore("public").getServer();
        return fileService.getFileStore("").getServer();
    }

    @RequestMapping("/exist")
    public boolean exist(@RequestParam String path) throws IOException {
        //return fileService.getFileStore("public").exist(path);
        return fileService.getFileStore("").exist(path);
    }

    @RequestMapping("/upload")
    public Object upload(@RequestParam String path, @RequestParam String md5, @RequestParam MultipartFile file)
            throws Exception {
        fileService.getFileStore("").write(path, file.getInputStream(), md5);
        return path;
    }

    @RequestMapping("/client/upload")
    public Object clientUpload(@RequestParam String path, @RequestParam String name) throws Exception {
        File file = new File(path);
        String md5 = ByteArray.md5(file).toHexString();
        return fileTestClient.upload(name, md5, UploadFile.build("file", name, file));
    }

    @RequestMapping("/client/server")
    public Object clientServer() throws IOException {
        return fileTestClient.getServer();
    }
}
