package com.qmth.demo.api.controller;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.boot.core.concurrent.annotation.Lockable;
import com.qmth.boot.core.concurrent.annotation.Locks;
import com.qmth.boot.core.concurrent.model.LockType;
import com.qmth.boot.core.concurrent.service.ConcurrentService;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/lock")
@Aac(strict = false, auth = false)
public class LockController {

    @Resource
    private ConcurrentService concurrentService;

    @RequestMapping("/lock")
    @Locks({ @Lockable(name = "test", key = "#key", type = LockType.READ),
            @Lockable(name = "test2", key = "#key", timeout = 0) })
    public Object lock(@RequestParam String key) {
        return key;
    }

    @RequestMapping("/tryLock")
    @Lockable(name = "test", timeout = 0)
    public Object tryLock(@RequestParam String key) {
        return key;
    }

    @RequestMapping("/tryWriteLock")
    public Object tryReadLock() throws InterruptedException {
        if (!concurrentService.getReadWriteLock("test").writeLock().tryLock()) {
            return false;
        }
        Thread.sleep(5000);
        concurrentService.getReadWriteLock("test").writeLock().unlock();
        return true;
    }

}
