package com.qmth.demo.api.controller;

import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.boot.core.sms.model.SmsSendRequest;
import com.qmth.boot.core.sms.service.SmsService;
import org.apache.commons.lang3.RandomStringUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/sms")
public class SmsController {

    @Resource
    private SmsService smsService;

    @RequestMapping("/send")
    public Object sendVerifySms(@RequestParam String phoneNumber, @RequestParam String signName,
            @RequestParam String templateCode, @RequestParam(required = false) String server) {
        SmsSendRequest request = new SmsSendRequest();
        request.setPhoneNumber(phoneNumber);
        request.setSignName(signName);
        request.setTemplateCode(templateCode);
        request.addParam("code", RandomStringUtils.random(4, false, true));
        return server != null ? smsService.sendSms(server, request) : smsService.sendSms(request);
    }

}
