package com.qmth.demo.api.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.demo.api.db.UserHome;
import com.qmth.demo.api.db.UserHomeMapper;
import com.qmth.demo.api.db.UserHomeQuery;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Date;

@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/user/home")
@Aac(strict = false, auth = false)
public class UserHomeController {

    @Resource
    private UserHomeMapper userHomeMapper;

    @RequestMapping("/list")
    public Object list(@Validated UserHomeQuery query) {
        query.orderByTime(true);
        return userHomeMapper.selectPage(query, new QueryWrapper<UserHome>().lambda()
                .eq(query.getUserId() != null, UserHome::getUserId, query.getUserId())
                .likeLeft(query.getHome() != null, UserHome::getHome, query.getHome())).getRecords();
    }

    @RequestMapping("/add")
    @Transactional
    public Object add(@RequestParam Long userId, @RequestParam String home) {
        UserHome uh = new UserHome();
        uh.setUserId(userId);
        uh.setHome(home);
        uh.setTime(new Date());
        userHomeMapper.insert(uh);
        return uh;
    }
}
