package com.qmth.demo.api.db;

import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.qmth.boot.mybatis.query.BaseQuery;
import org.springframework.validation.annotation.Validated;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;

@Validated
public class UserHomeQuery extends BaseQuery<UserHome> {

    private static final long serialVersionUID = 5135300934708947962L;

    private Long userId;

    private String home;

    public void orderByTime(boolean asc) {
        addOrder(new OrderItem("time", asc));
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public String getHome() {
        return home;
    }

    public void setHome(String home) {
        this.home = home;
    }

    @Min(1)
    public long getPageNumber() {
        return super.getPageNumber();
    }

    @Min(1)
    @Max(100)
    public long getPageSize() {
        return super.getPageSize();
    }

}
