package com.qmth.demo.api.db;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;

import java.util.List;

public interface UserMapper extends BaseMapper<User> {

    List<User> findByQuery(UserQuery query);

    //MybatisPlus内置规则，开启autoResultMap后，名称为mybatis-plus_XXX
    @ResultMap("mybatis-plus_User")
    @Select("select * from user where enable=#{enable}")
    List<User> findByEnable(boolean enable);

    @ResultMap("mybatis-plus_User")
    @Select("select * from user where name like concat(#{name},'%')")
    List<User> findByName(String name);
}
