package com.qmth.demo.api.db;

import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.qmth.boot.mybatis.query.BaseQuery;
import org.springframework.validation.annotation.Validated;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;

@Validated
public class UserQuery extends BaseQuery<User> {

    private static final long serialVersionUID = 5160957717754609086L;

    @NotBlank(message = "User.name不能为空")
    private String name;

    private Boolean enable;

    private Gender gender;

    public void orderByNameDesc() {
        addOrder(new OrderItem("name", false));
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Boolean getEnable() {
        return enable;
    }

    public void setEnable(Boolean enable) {
        this.enable = enable;
    }

    public Gender getGender() {
        return gender;
    }

    public void setGender(Gender gender) {
        this.gender = gender;
    }

    @Min(1)
    public long getPageNumber() {
        return super.getPageNumber();
    }

    @Min(1)
    @Max(100)
    public long getPageSize() {
        return super.getPageSize();
    }

}
