package com.qmth.demo.api.service;

import com.qmth.demo.api.entity.DemoCacheString;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Component;

@Component
public class DemoCacheService {

    public static final String CACHE_NAME = "demo-cache";

    @Cacheable(value = CACHE_NAME, key = "#key", unless = "#result == null")
    public DemoCacheString get(String key) {
        return key.equals("null") ? null : new DemoCacheString(key);
    }

    @CachePut(value = CACHE_NAME, key = "#key", unless = "#result == null")
    public DemoCacheString put(String key, String value) {
        return new DemoCacheString(value);
    }

    @CacheEvict(value = CACHE_NAME, key = "#key", beforeInvocation = true)
    public boolean clear(String key) {
        return true;
    }
}
