package com.qmth.demo.api.service;

import com.qmth.demo.api.db.Gender;
import com.qmth.demo.api.db.User;
import com.qmth.demo.api.db.UserMapper;
import com.qmth.demo.api.event.TestEvent;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

@Service
public class DemoEventService {

    @Resource
    private UserMapper userMapper;

    @EventListener
    @Transactional
    public void onTestEvent(TestEvent event) {
        User user = new User();
        user.setName(event.getName());
        user.setGender(Gender.MALE);
        user.setEnable(true);
        userMapper.insert(user);
    }
}
