package com.qmth.boot.data.upgrade.demo.service;

import com.qmth.boot.data.upgrade.annotation.DataUpgradeVersion;
import com.qmth.boot.data.upgrade.service.DataUpgradeService;
import com.qmth.boot.data.upgrade.utils.ResourceFileHelper;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.jdbc.core.JdbcTemplate;

import java.util.Arrays;

@DataUpgradeVersion("1.0.3")
public class DataUpgrade_1_0_3 implements DataUpgradeService {

    private static final Logger log = LoggerFactory.getLogger(DataUpgrade_1_0_3.class);

    @Override
    public void process(JdbcTemplate jdbcTemplate) throws Exception {
        log.info("process...");

        String[] sqlList = StringUtils.split(ResourceFileHelper.readContent("upgrade/1.0.3.sql"), ";");
        Arrays.stream(sqlList).filter(StringUtils::isNotBlank).forEach(sql -> {
            log.info(sql);
            jdbcTemplate.execute(sql);
        });
    }

}
